unit iMessage;

interface

function    GetMessageName(AMsg: Integer): string;

implementation

uses
    SysUtils, Classes, Messages, IniFiles;

var
    MsgList: TStringList;

function    GetMessageName(AMsg: Integer): string;
var
    N: Integer;
begin
    N := MsgList.IndexOfObject(TObject(AMsg));
    if N >= 0 then
    begin
        Result := MsgList[N];
    end
    else
    if AMsg >= wm_User then
    begin
        Result := 'wm_User message     '
    end
    else
    begin
        Result := 'Unknown message     ';
    end;
end;

initialization
    //  Xg쐬
    MsgList := THashedStringList.Create;

    //  bZ[Wo^
    MsgList.AddObject('WM_NULL', TObject($0000));
    MsgList.AddObject('WM_CREATE', TObject($0001));
    MsgList.AddObject('WM_DESTROY', TObject($0002));
    MsgList.AddObject('WM_MOVE', TObject($0003));
    //
    MsgList.AddObject('WM_SIZE', TObject($0005));
    MsgList.AddObject('WM_ACTIVATE', TObject($0006));
    MsgList.AddObject('WM_SETFOCUS', TObject($0007));
    MsgList.AddObject('WM_KILLFOCUS', TObject($0008));
    //
    MsgList.AddObject('WM_ENABLE', TObject($000A));
    MsgList.AddObject('WM_SETREDRAW', TObject($000B));
    MsgList.AddObject('WM_SETTEXT', TObject($000C));
    MsgList.AddObject('WM_GETTEXT', TObject($000D));
    MsgList.AddObject('WM_GETTEXTLENGTH', TObject($000E));
    MsgList.AddObject('WM_PAINT', TObject($000F));
    MsgList.AddObject('WM_CLOSE', TObject($0010));
    MsgList.AddObject('WM_QUERYENDSESSION', TObject($0011));
    MsgList.AddObject('WM_QUIT', TObject($0012));
    MsgList.AddObject('WM_QUERYOPEN', TObject($0013));
    MsgList.AddObject('WM_ERASEBKGND', TObject($0014));
    MsgList.AddObject('WM_SYSCOLORCHANGE', TObject($0015));
    MsgList.AddObject('WM_ENDSESSION', TObject($0016));
    MsgList.AddObject('WM_SYSTEMERROR', TObject($0017));
    MsgList.AddObject('WM_SHOWWINDOW', TObject($0018));
    MsgList.AddObject('WM_CTLCOLOR', TObject($0019));
    MsgList.AddObject('WM_WININICHANGE', TObject($001A));  // WM_WININICHANGE
    MsgList.AddObject('WM_DEVMODECHANGE', TObject($001B));
    MsgList.AddObject('WM_ACTIVATEAPP', TObject($001C));
    MsgList.AddObject('WM_FONTCHANGE', TObject($001D));
    MsgList.AddObject('WM_TIMECHANGE', TObject($001E));
    MsgList.AddObject('WM_CANCELMODE', TObject($001F));
    MsgList.AddObject('WM_SETCURSOR', TObject($0020));
    MsgList.AddObject('WM_MOUSEACTIVATE', TObject($0021));
    MsgList.AddObject('WM_CHILDACTIVATE', TObject($0022));
    MsgList.AddObject('WM_QUEUESYNC', TObject($0023));
    MsgList.AddObject('WM_GETMINMAXINFO', TObject($0024));
    //
    MsgList.AddObject('WM_PAINTICON', TObject($0026));
    MsgList.AddObject('WM_ICONERASEBKGND', TObject($0027));
    MsgList.AddObject('WM_NEXTDLGCTL', TObject($0028));
    //
    MsgList.AddObject('WM_SPOOLERSTATUS', TObject($002A));
    MsgList.AddObject('WM_DRAWITEM', TObject($002B));
    MsgList.AddObject('WM_MEASUREITEM', TObject($002C));
    MsgList.AddObject('WM_DELETEITEM', TObject($002D));
    MsgList.AddObject('WM_VKEYTOITEM', TObject($002E));
    MsgList.AddObject('WM_CHARTOITEM', TObject($002F));
    MsgList.AddObject('WM_SETFONT', TObject($0030));
    MsgList.AddObject('WM_GETFONT', TObject($0031));
    MsgList.AddObject('WM_SETHOTKEY', TObject($0032));
    MsgList.AddObject('WM_GETHOTKEY', TObject($0033));
    //
    MsgList.AddObject('WM_QUERYDRAGICON', TObject($0037));
    //
    MsgList.AddObject('WM_COMPAREITEM', TObject($0039));
    //
    MsgList.AddObject('WM_GETOBJECT', TObject($003D));
    //
    MsgList.AddObject('WM_COMPACTING', TObject($0041));
    //
    MsgList.AddObject('WM_COMMNOTIFY', TObject($0044));
    //
    MsgList.AddObject('WM_WINDOWPOSCHANGING', TObject($0046));
    MsgList.AddObject('WM_WINDOWPOSCHANGED', TObject($0047));
    MsgList.AddObject('WM_POWER', TObject($0048));
    //
    MsgList.AddObject('WM_COPYDATA', TObject($004A));
    MsgList.AddObject('WM_CANCELJOURNAL', TObject($004B));
    //
    MsgList.AddObject('WM_NOTIFY', TObject($004E));
    //
    MsgList.AddObject('WM_INPUTLANGCHANGEREQUEST', TObject($0050));
    MsgList.AddObject('WM_INPUTLANGCHANGE', TObject($0051));
    MsgList.AddObject('WM_TCARD', TObject($0052));
    MsgList.AddObject('WM_HELP', TObject($0053));
    MsgList.AddObject('WM_USERCHANGED', TObject($0054));
    MsgList.AddObject('WM_NOTIFYFORMAT', TObject($0055));
    //
    MsgList.AddObject('WM_CONTEXTMENU', TObject($007B));
    MsgList.AddObject('WM_STYLECHANGING', TObject($007C));
    MsgList.AddObject('WM_STYLECHANGED', TObject($007D));
    MsgList.AddObject('WM_DISPLAYCHANGE', TObject($007E));
    MsgList.AddObject('WM_GETICON', TObject($007F));
    MsgList.AddObject('WM_SETICON', TObject($0080));
    MsgList.AddObject('WM_NCCREATE', TObject($0081));
    MsgList.AddObject('WM_NCDESTROY', TObject($0082));
    MsgList.AddObject('WM_NCCALCSIZE', TObject($0083));
    MsgList.AddObject('WM_NCHITTEST', TObject($0084));
    MsgList.AddObject('WM_NCPAINT', TObject($0085));
    MsgList.AddObject('WM_NCACTIVATE', TObject($0086));
    MsgList.AddObject('WM_GETDLGCODE', TObject($0087));
    //
    MsgList.AddObject('WM_NCMOUSEMOVE', TObject($00A0));
    MsgList.AddObject('WM_NCLBUTTONDOWN', TObject($00A1));
    MsgList.AddObject('WM_NCLBUTTONUP', TObject($00A2));
    MsgList.AddObject('WM_NCLBUTTONDBLCLK', TObject($00A3));
    MsgList.AddObject('WM_NCRBUTTONDOWN', TObject($00A4));
    MsgList.AddObject('WM_NCRBUTTONUP', TObject($00A5));
    MsgList.AddObject('WM_NCRBUTTONDBLCLK', TObject($00A6));
    MsgList.AddObject('WM_NCMBUTTONDOWN', TObject($00A7));
    MsgList.AddObject('WM_NCMBUTTONUP', TObject($00A8));
    MsgList.AddObject('WM_NCMBUTTONDBLCLK', TObject($00A9));
    MsgList.AddObject('WM_KEYDOWN', TObject($0100));  // WM_KEYFIRST
    MsgList.AddObject('WM_KEYUP', TObject($0101));
    MsgList.AddObject('WM_CHAR', TObject($0102));
    MsgList.AddObject('WM_DEADCHAR', TObject($0103));
    MsgList.AddObject('WM_SYSKEYDOWN', TObject($0104));
    MsgList.AddObject('WM_SYSKEYUP', TObject($0105));
    MsgList.AddObject('WM_SYSCHAR', TObject($0106));
    MsgList.AddObject('WM_SYSDEADCHAR', TObject($0107));
    MsgList.AddObject('WM_KEYLAST', TObject($0108));
    //
    MsgList.AddObject('WM_IME_STARTCOMPOSITION', TObject($010D));
    MsgList.AddObject('WM_IME_ENDCOMPOSITION', TObject($010E));
    MsgList.AddObject('WM_IME_COMPOSITION', TObject($010F));   //  WM_IME_KEYLAST
    MsgList.AddObject('WM_INITDIALOG', TObject($0110));
    MsgList.AddObject('WM_COMMAND', TObject($0111));
    MsgList.AddObject('WM_SYSCOMMAND', TObject($0112));
    MsgList.AddObject('WM_TIMER', TObject($0113));
    MsgList.AddObject('WM_HSCROLL', TObject($0114));
    MsgList.AddObject('WM_VSCROLL', TObject($0115));
    MsgList.AddObject('WM_INITMENU', TObject($0116));
    MsgList.AddObject('WM_INITMENUPOPUP', TObject($0117));
    //
    MsgList.AddObject('WM_MENUSELECT', TObject($011F));
    MsgList.AddObject('WM_MENUCHAR', TObject($0120));
    MsgList.AddObject('WM_ENTERIDLE', TObject($0121));
    MsgList.AddObject('WM_MENURBUTTONUP', TObject($0122));
    MsgList.AddObject('WM_MENUDRAG', TObject($0123));
    MsgList.AddObject('WM_MENUGETOBJECT', TObject($0124));
    MsgList.AddObject('WM_UNINITMENUPOPUP', TObject($0125));
    MsgList.AddObject('WM_MENUCOMMAND', TObject($0126));
    MsgList.AddObject('WM_CHANGEUISTATE', TObject($0127));
    MsgList.AddObject('WM_UPDATEUISTATE', TObject($0128));
    MsgList.AddObject('WM_QUERYUISTATE', TObject($0129));
    //
    MsgList.AddObject('WM_CTLCOLORMSGBOX', TObject($0132));
    MsgList.AddObject('WM_CTLCOLOREDIT', TObject($0133));
    MsgList.AddObject('WM_CTLCOLORLISTBOX', TObject($0134));
    MsgList.AddObject('WM_CTLCOLORBTN', TObject($0135));
    MsgList.AddObject('WM_CTLCOLORDLG', TObject($0136));
    MsgList.AddObject('WM_CTLCOLORSCROLLBAR', TObject($0137));
    MsgList.AddObject('WM_CTLCOLORSTATIC', TObject($0138));
    //
    MsgList.AddObject('WM_MOUSEMOVE', TObject($0200));      //  WM_MOUSEFIRST
    MsgList.AddObject('WM_LBUTTONDOWN', TObject($0201));
    MsgList.AddObject('WM_LBUTTONUP', TObject($0202));
    MsgList.AddObject('WM_LBUTTONDBLCLK', TObject($0203));
    MsgList.AddObject('WM_RBUTTONDOWN', TObject($0204));
    MsgList.AddObject('WM_RBUTTONUP', TObject($0205));
    MsgList.AddObject('WM_RBUTTONDBLCLK', TObject($0206));
    MsgList.AddObject('WM_MBUTTONDOWN', TObject($0207));
    MsgList.AddObject('WM_MBUTTONUP', TObject($0208));
    MsgList.AddObject('WM_MBUTTONDBLCLK', TObject($0209));
    MsgList.AddObject('WM_MOUSEWHEEL', TObject($020A));     //  WM_MOUSELAST
    MsgList.AddObject('WM_PARENTNOTIFY', TObject($0210));
    MsgList.AddObject('WM_ENTERMENULOOP', TObject($0211));
    MsgList.AddObject('WM_EXITMENULOOP', TObject($0212));
    MsgList.AddObject('WM_NEXTMENU', TObject($0213));
    MsgList.AddObject('WM_SIZING', TObject($0214));         //  532
    MsgList.AddObject('WM_CAPTURECHANGED', TObject($0215)); //  533
    MsgList.AddObject('WM_MOVING', TObject($0216));         //  534
    //
    MsgList.AddObject('WM_POWERBROADCAST', TObject($0218)); //  536
    MsgList.AddObject('WM_DEVICECHANGE', TObject($0219));   //  537
    //
    MsgList.AddObject('WM_MDICREATE', TObject($0220));
    MsgList.AddObject('WM_MDIDESTROY', TObject($0221));
    MsgList.AddObject('WM_MDIACTIVATE', TObject($0222));
    MsgList.AddObject('WM_MDIRESTORE', TObject($0223));
    MsgList.AddObject('WM_MDINEXT', TObject($0224));
    MsgList.AddObject('WM_MDIMAXIMIZE', TObject($0225));
    MsgList.AddObject('WM_MDITILE', TObject($0226));
    MsgList.AddObject('WM_MDICASCADE', TObject($0227));
    MsgList.AddObject('WM_MDIICONARRANGE', TObject($0228));
    MsgList.AddObject('WM_MDIGETACTIVE', TObject($0229));
    //
    MsgList.AddObject('WM_MDISETMENU', TObject($0230));
    MsgList.AddObject('WM_ENTERSIZEMOVE', TObject($0231));
    MsgList.AddObject('WM_EXITSIZEMOVE', TObject($0232));
    MsgList.AddObject('WM_DROPFILES', TObject($0233));
    MsgList.AddObject('WM_MDIREFRESHMENU', TObject($0234));
    //
    MsgList.AddObject('WM_IME_SETCONTEXT', TObject($0281));
    MsgList.AddObject('WM_IME_NOTIFY', TObject($0282));
    MsgList.AddObject('WM_IME_CONTROL', TObject($0283));
    MsgList.AddObject('WM_IME_COMPOSITIONFULL', TObject($0284));
    MsgList.AddObject('WM_IME_SELECT', TObject($0285));
    MsgList.AddObject('WM_IME_CHAR', TObject($0286));
    MsgList.AddObject('WM_IME_REQUEST', TObject($0288));
    MsgList.AddObject('WM_IME_KEYDOWN', TObject($0290));
    MsgList.AddObject('WM_IME_KEYUP', TObject($0291));
    //
    MsgList.AddObject('WM_MOUSEHOVER', TObject($02A1));
    //
    MsgList.AddObject('WM_MOUSELEAVE', TObject($02A3));
    //
    MsgList.AddObject('WM_CUT', TObject($0300));
    MsgList.AddObject('WM_COPY', TObject($0301));
    MsgList.AddObject('WM_PASTE', TObject($0302));
    MsgList.AddObject('WM_CLEAR', TObject($0303));
    MsgList.AddObject('WM_UNDO', TObject($0304));
    MsgList.AddObject('WM_RENDERFORMAT', TObject($0305));
    MsgList.AddObject('WM_RENDERALLFORMATS', TObject($0306));
    MsgList.AddObject('WM_DESTROYCLIPBOARD', TObject($0307));
    MsgList.AddObject('WM_DRAWCLIPBOARD', TObject($0308));
    MsgList.AddObject('WM_PAINTCLIPBOARD', TObject($0309));
    MsgList.AddObject('WM_VSCROLLCLIPBOARD', TObject($030A));
    MsgList.AddObject('WM_SIZECLIPBOARD', TObject($030B));
    MsgList.AddObject('WM_ASKCBFORMATNAME', TObject($030C));
    MsgList.AddObject('WM_CHANGECBCHAIN', TObject($030D));
    MsgList.AddObject('WM_HSCROLLCLIPBOARD', TObject($030E));
    MsgList.AddObject('WM_QUERYNEWPALETTE', TObject($030F));
    MsgList.AddObject('WM_PALETTEISCHANGING', TObject($0310));
    MsgList.AddObject('WM_PALETTECHANGED', TObject($0311));
    MsgList.AddObject('WM_HOTKEY', TObject($0312));
    //
    MsgList.AddObject('WM_PRINT', TObject($0317));          //  791
    MsgList.AddObject('WM_PRINTCLIENT', TObject($0318));    //  792
    //
    MsgList.AddObject('WM_HANDHELDFIRST', TObject($0358));  //  856
    //
    MsgList.AddObject('WM_HANDHELDLAST', TObject($035F));   //  863
    //
    MsgList.AddObject('WM_PENWINFIRST', TObject($0380));
    MsgList.AddObject('WM_PENWINLAST', TObject($038F));
    MsgList.AddObject('WM_COALESCE_FIRST', TObject($0390));
    MsgList.AddObject('WM_COALESCE_LAST', TObject($039F));
    MsgList.AddObject('WM_DDE_INITIATE', TObject($03E0));   //  WM_DDE_FIRST
    MsgList.AddObject('WM_DDE_TERMINATE', TObject($03E1));  //  WM_DDE_FIRST + 1
    MsgList.AddObject('WM_DDE_ADVISE', TObject($03E2));     //  WM_DDE_FIRST + 2
    MsgList.AddObject('WM_DDE_UNADVISE', TObject($03E3));   //  WM_DDE_FIRST + 3
    MsgList.AddObject('WM_DDE_ACK', TObject($03E4));        //  WM_DDE_FIRST + 4
    MsgList.AddObject('WM_DDE_DATA', TObject($03E5));       //  WM_DDE_FIRST + 5
    MsgList.AddObject('WM_DDE_REQUEST', TObject($03E6));    //  WM_DDE_FIRST + 6
    MsgList.AddObject('WM_DDE_POKE', TObject($03E7));       //  WM_DDE_FIRST + 7
    MsgList.AddObject('WM_DDE_EXECUTE', TObject($03E8));    //  WM_DDE_FIRST + 8 = WM_DDE_LAST
    //
    MsgList.AddObject('WM_APP', TObject($8000));
    //
    MsgList.AddObject('DM_GETDEFID', TObject($0400));   //  WM_USER
    MsgList.AddObject('DM_SETDEFID', TObject($0401));   //  WM_USER + 1
    MsgList.AddObject('DM_REPOSITION', TObject($0402)); //  WM_USER + 2
    //
    MsgList.AddObject('PSM_PAGEINFO', TObject($0464));  //  WM_USER + 100
    MsgList.AddObject('PSM_SHEETINFO', TObject($0465)); //  WM_USER + 101

finalization

    MsgList.Free;

end.

